#include <windows.h>
#include <tchar.h>
#include "32gm32.h"

#pragma comment(lib, "32gm32.lib")

#define MYWNDCLASS		TEXT("CLASS_32gm32test")
#define MYWNDTITLE		TEXT("32gm32test")

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

int WINAPI _tWinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPTSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				NULL,
				NULL,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP	hBmp1,hBmp2,hBmp3;
	
	switch (uMsg)
	{
	case WM_CREATE:
		hBmp1 = b32New(512, 512);
		hBmp2 = b32Load(TEXT("map0_bk.bmp"));
		hBmp3 = b32Load(TEXT("map0_ly.bmp"));
		g32SetMapViewSize(14, 10);
		g32LoadMapData(TEXT("map0.bin"));
		return 0;
	case WM_PAINT:
		{
			HDC 		hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd,&ps);
			b32DrawColor(hBmp1, 255, 255, 255, 0);
			g32DrawMap(hBmp1, hBmp2, hBmp3);
			g32DrawPriorityMap(hBmp1, hBmp3);
			g32DrawHitJudge(hBmp1);
			b32DrawDC(hDC, 0, 0, hBmp1, 0, 0, b32GetWidth(hBmp1), b32GetHeight(hBmp1));
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		b32Delete(hBmp1);
		b32Delete(hBmp2);
		b32Delete(hBmp3);
		g32DeleteMapData();
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

