#define _CRT_SECURE_NO_WARNINGS
#include "32gm32.h"
#include <tchar.h>
#include <stdio.h>

#define SAFE_FREE(p)	if (p){free(p);p=NULL;}

#define CHIP_SIZE			32	// }bv`bv̂P`bv̈ӂ̒i32 Œj
#define CHIP_IMG_COL		16	// }bv`bv̏c̐i16 Œj
#define CHIP_IMG_ROW		16	// }bv`bv̉̐i16 Œj

#define HIT_SIZE			32	// 蔻TCY i32 Œj

#define BYTE_MASK_BG		0x000000FF
#define BYTE_MASK_FLG		0x0000FF00
#define BYTE_MASK_LYER		0x00FF0000
#define BYTE_MASK_UNDEF		0xFF000000

#define BIT_MASK_HIT16_0	0x00000100
#define BIT_MASK_HIT16_1	0x00000200
#define BIT_MASK_HIT16_2	0x00000400
#define BIT_MASK_HIT16_3	0x00000800
#define BIT_MASK_PRI16_0	0x00001000
#define BIT_MASK_PRI16_1	0x00002000
#define BIT_MASK_PRI16_2	0x00004000
#define BIT_MASK_PRI16_3	0x00008000

#define BYTE_SHIFT_BG		0
#define BYTE_SHIFT_FLG		8
#define BYTE_SHIFT_LYER		16
#define BYTE_SHIFT_UNDEF	24

int				gMapSizeX		= 0;		// `bv/}bvij
int				gMapSizeY		= 0;		// `bv/}bvicj
int				gMapViewWidth	= 10;		// }bv\TCYij
int				gMapViewHeight	= 8;		// }bv\TCYij
unsigned long	*gpMapData		= NULL;		// }bvf[^
BOOL			gbColorkey		= false;	// J[L[tO
BYTE			gbkeyRed		= 0;		// J[L[iԁj
BYTE			gbkeyGreen		= 0;		// J[L[i΁j
BYTE			gbkeyBlue		= 0;		// J[L[ij

// J[L[tO擾
BOOL g32GetColorKeyFlag()
{
	return gbColorkey;
}// g32GetColorKeyFlag

// J[L[tOݒ
void g32SetColorKeyFlag(BOOL flag)
{
	gbColorkey = flag;
}// g32SetColorKeyFlag

// J[L[擾
DWORD g32GetColorKey()
{
	return RGB(gbkeyRed, gbkeyGreen, gbkeyBlue);
}// g32GetColorKey

// J[L[ݒ
void g32SetColorKey(BYTE red, BYTE green, BYTE blue)
{
	gbkeyRed	= red;
	gbkeyGreen	= green;
	gbkeyBlue	= blue;
	gbColorkey	= TRUE;
}// g32SetColorKey

// }bvTCY̎擾
POINT g32GetMapSize()
{
	POINT pt = {gMapSizeX, gMapSizeY};
	return pt;
}// g32GetMapSize

// }bv\TCY̎擾
POINT g32GetMapViewSize()
{
	POINT pt = {gMapViewWidth, gMapViewHeight};
	return pt;
}// g32GetMapViewSize

// }bv\TCY̐ݒ
void g32SetMapViewSize(int width, int height)
{
	gMapViewWidth  = width;
	gMapViewHeight = height;
}// g32SetMapViewSize

// }bvf[^̎擾
unsigned long* g32GetMapData()
{
	return gpMapData;
}// g32GetMapData

// }bvf[^̍폜
void g32DeleteMapData()
{
	SAFE_FREE(gpMapData);
}// g32DeleteMapData

//	}bvf[^i.binjǂݍ
BOOL g32LoadMapData(TCHAR *filename)
{
	FILE *fp = _tfopen(filename, _T("rb"));
	if (fp == NULL) {
		return FALSE;
	}
	
	// WAcW̓ǂݍ
	gMapSizeX  = fgetc(fp);
	gMapSizeX |= fgetc(fp) << 8;
	gMapSizeX |= fgetc(fp) << 16;
	gMapSizeX |= fgetc(fp) << 24;
	
	gMapSizeY  = fgetc(fp);
	gMapSizeY |= fgetc(fp) << 8;
	gMapSizeY |= fgetc(fp) << 16;
	gMapSizeY |= fgetc(fp) << 24;
	
	// }bvf[^zm
	int i;
	int size = sizeof(unsigned long) * gMapSizeX * gMapSizeY;
	SAFE_FREE(gpMapData);
	gpMapData = (unsigned long *)malloc(size);
	ZeroMemory(gpMapData, size);
	
	// zɊi[
	unsigned char *p = (unsigned char *)gpMapData;
	
	for (i = 0; i < size; i++) {
		if (feof(fp)){
			SAFE_FREE(gpMapData);
			return false;
		}
		*p = fgetc(fp);
		p++;
	}
	
	fclose(fp);
	
	return TRUE;
}// g32Load_MapData

//	}bv̕\
//@hBmpDst			: [IN][OUT]	obNobt@
//@hBmpMapChip		: [IN]		}bv`bv
//@hBmpLyerChip	: [IN]		C[`bv
//@scr_x, scr_y	: [IN]		}bṽXN[ʒu
//@x, y			: [IN]		}bv̍W
BOOL g32DrawMap(HBITMAP hBmpDst, HBITMAP hBmpMapChip, HBITMAP hBmpLyerChip, int scr_x, int scr_y, int x, int y)
{
	if(!gpMapData)
		return FALSE;
	
	if(scr_x < 0)
		scr_x = 0;
	if(scr_y < 0)
		scr_y = 0;
	
	int i, j, pos;
	int map_left   = scr_x / CHIP_SIZE;
	int map_right  = map_left + gMapViewWidth;
	int map_top    = scr_y / CHIP_SIZE;
	int map_bottom = map_top + gMapViewHeight;
	
	if (scr_x % CHIP_SIZE)
		map_right  ++;
	if (scr_y % CHIP_SIZE)
		map_bottom ++;
	if (map_right  > gMapSizeX)
		map_right  = gMapSizeX;
	if (map_bottom > gMapSizeY)
		map_bottom = gMapSizeY;
	
	for (i = map_top; i < map_bottom; i++) {
		for (j = map_left; j < map_right; j++) {
			pos = i * gMapSizeX + j;
			// wi\
			int idx = gpMapData[pos] & BYTE_MASK_BG;
			int x2 = j * CHIP_SIZE + x - scr_x;
			int y2 = i * CHIP_SIZE + y - scr_y;
			int u2 = idx % CHIP_IMG_ROW;
			int v2 = idx / CHIP_IMG_ROW;
			int u = u2 * CHIP_SIZE;
			int v = v2 * CHIP_SIZE;
			b32Draw(hBmpDst, x2, y2, hBmpMapChip, u, v, CHIP_SIZE, CHIP_SIZE);
			// C[\
			if(HIT_SIZE == 32 && !(gpMapData[pos] & BIT_MASK_PRI16_0)){
				idx = (gpMapData[pos] & BYTE_MASK_LYER) >> BYTE_SHIFT_LYER;
				if(idx != 0) { // `bvhcÔ͍ߕ`悵Ȃ
					int u = (idx % CHIP_IMG_ROW) * CHIP_SIZE;
					int v = (idx / CHIP_IMG_ROW) * CHIP_SIZE;
					if(g32GetColorKeyFlag())
						b32DrawKey(hBmpDst, x2, y2, hBmpLyerChip, u, v, CHIP_SIZE, CHIP_SIZE, gbkeyRed, gbkeyGreen, gbkeyBlue);
					else
						b32Draw32(hBmpDst, x2, y2, hBmpLyerChip, u, v, CHIP_SIZE, CHIP_SIZE, 255);
				}
			}
		}
	}
	
	return TRUE;
}// g32DrawMap

//	vCIeB̍C[`bv̕\
//@hBmpDst			: [IN][OUT]	obNobt@
//@hBmpLyerChip	: [IN]		C[`bv
//@scr_x, scr_y	: [IN]		}bṽXN[ʒu
//@x, y			: [IN]		}bv̍W
BOOL g32DrawPriorityMap(HBITMAP hBmpDst, HBITMAP hBmpLyerChip, int scr_x, int scr_y, int x, int y)
{
	if(!gpMapData)
		return FALSE;
	
	if(scr_x < 0)
		scr_x = 0;
	if(scr_y < 0)
		scr_y = 0;
	
	int i, j, pos;
	int map_left   = scr_x / CHIP_SIZE;
	int map_right  = map_left + gMapViewWidth;
	int map_top    = scr_y / CHIP_SIZE;
	int map_bottom = map_top + gMapViewHeight;
	
	if (scr_x % CHIP_SIZE)
		map_right  ++;
	if (scr_y % CHIP_SIZE)
		map_bottom ++;
	if (map_right  > gMapSizeX)
		map_right  = gMapSizeX;
	if (map_bottom > gMapSizeY)
		map_bottom = gMapSizeY;
	
	for (i = map_top; i < map_bottom; i++) {
		for (j = map_left; j < map_right; j++) {
			pos = i * gMapSizeX + j;
			// C[\
			if(HIT_SIZE == 32 && (gpMapData[pos] & BIT_MASK_PRI16_0)){
				int idx = (gpMapData[pos] & BYTE_MASK_LYER) >> BYTE_SHIFT_LYER;
				if(idx != 0) { // `bvhcÔ͍ߕ`悵Ȃ
					int x2 = j * CHIP_SIZE + x - scr_x;
					int y2 = i * CHIP_SIZE + y - scr_y;
					int u = (idx % CHIP_IMG_ROW) * CHIP_SIZE;
					int v = (idx / CHIP_IMG_ROW) * CHIP_SIZE;
					if(g32GetColorKeyFlag())
						b32DrawKey(hBmpDst, x2, y2, hBmpLyerChip, u, v, CHIP_SIZE, CHIP_SIZE, gbkeyRed, gbkeyGreen, gbkeyBlue);
					else
						b32Draw32(hBmpDst, x2, y2, hBmpLyerChip, u, v, CHIP_SIZE, CHIP_SIZE, 255);
				}
			}
		}
	}
	
	return TRUE;
}// g32DrawPriorityMap

//	蔻̕\
//@hBmp			: [IN][OUT]	obNobt@
//@scr_x, scr_y	: [IN]		}bṽXN[ʒu
//@x, y			: [IN]		}bv̍W
//@red				: [IN]		ԐF
//@green			: [IN]		ΐF
//@blue 			: [IN]		F
BOOL g32DrawHitJudge(HBITMAP hBmp, int scr_x, int scr_y, int x, int y, BYTE red, BYTE green, BYTE blue)
{
	if(!gpMapData)
		return FALSE;
	
	if(scr_x < 0)
		scr_x = 0;
	if(scr_y < 0)
		scr_y = 0;
	
	int i, j;
	int map_left   = scr_x / CHIP_SIZE;
	int map_right  = map_left + gMapViewWidth;
	int map_top    = scr_y / CHIP_SIZE;
	int map_bottom = map_top + gMapViewHeight;
	
	if (scr_x % CHIP_SIZE)
		map_right  ++;
	if (scr_y % CHIP_SIZE)
		map_bottom ++;
	if (map_right  > gMapSizeX)
		map_right  = gMapSizeX;
	if (map_bottom > gMapSizeY)
		map_bottom = gMapSizeY;
	
	// 蔻̕`
	if(gpMapData){
		for (i = map_top; i < map_bottom; i++) {
			for (j = map_left; j < map_right; j++) {
				if(gpMapData[i * gMapSizeX + j] & BIT_MASK_HIT16_0){
					int x2 = j * HIT_SIZE + x - scr_x;
					int y2 = i * HIT_SIZE + y - scr_y;
					b32AddColor(hBmp, red, green, blue, x2, y2, HIT_SIZE, HIT_SIZE);
				}
			}
		}
	}
	
	return TRUE;
}// g32DrawHitJudge
